#include <SDL.h>
#include <SDL_image.h>
#include "tools.h"
#include "main.h"
#include "SDLgraph.h"
#include "aAsteroid.h"


Mix_Chunk* aAsteroid::Sound = NULL;


SDL_Texture *AsteroidImage[64];
SDL_Texture *AsteroidExplodeImage[20];


void LoadAsteroidImageData()
{
	for (int i=0;i<64; i++)
	{
		AsteroidImage[i] = LoadSprite(_DATA_FOLDER_+"/graph/asteroid/ASTERO"+numstr(i)+".bmp");
	}

	for (int i=0;i<20; i++)
	{
		AsteroidExplodeImage[i] = LoadSprite(_DATA_FOLDER_+"/graph/astexp/ASTEXP"+numstr(i)+".bmp");
	}

}


void FreeAsteroidData()
{	
	for (int i=0;i<64; i++)
	{
		SDL_DestroyTexture(AsteroidImage[i]);
	}

	for (int i=0;i<20; i++)
	{
		SDL_DestroyTexture(AsteroidExplodeImage[i]);
	}
}






aAsteroid::aAsteroid()
{
	nodeName="aAsteroid";
	

	if (!Sound) if (!(Sound = Mix_LoadWAV(stringchar(_DATA_FOLDER_+"/sound/asteroid.wav")))) error("Mix_LoadWAV 'asteroid.wav' fails");


	Reset();
}



aAsteroid::~aAsteroid()
{
	Mix_FreeChunk(Sound);
}


void aAsteroid::Reset()
{
	rotFrame=0;
	explodeFrame=0;

	x = rand()%screenwidth - 60;
	y = - 60;
	
	explode = false;
	speed=rand()%maxspeed+1;

	soundPlayed=false;
	quiet=false;
}

void aAsteroid::update(void *data)
{
	y+=speed;

	rotFrame++;
	if (rotFrame>=64) rotFrame = 0;
	
	if (y>screenheight) 
	{
		x = rand()%screenwidth - 60;
		y = - 60;	
	}

	if (explode)
	{
		if (!soundPlayed)
		{
			soundPlayed=true;
			if (!quiet) if(!Mix_PlayChannel(1, Sound, 0)) error("Mix_PlayChannel1 'Asteroid' fails");
		}
		explodeFrame++;
		if (explodeFrame>=20) 
		{
			Reset();
			aAsteroid *newAsteroid = new aAsteroid();
			myScene->addNode(newAsteroid);
		}
	}
}


void aAsteroid::render()
{
	if (!nodeAlive) return;

	SDL_Rect myrect;

	if (!explode)
	{
		SDL_QueryTexture(AsteroidImage[rotFrame], NULL, NULL, &myrect.w, &myrect.h);
		myrect.x=x;
		myrect.y=y;

		SDL_RenderCopy(SDLren, AsteroidImage[rotFrame], NULL, &myrect);
	} else {

		SDL_QueryTexture(AsteroidImage[rotFrame], NULL, NULL, &myrect.w, &myrect.h);
		myrect.x=x;
		myrect.y=y;

		SDL_RenderCopy(SDLren, AsteroidExplodeImage[explodeFrame], NULL, &myrect);

	}
}

