#include <SDL.h>
#include <SDL_image.h>
#include "tools.h"
#include "main.h"
#include "SDLgraph.h"
#include "aShot.h"
#include "aShip.h"
#include "aAsteroid.h"


aShip::aShip()
{
	nodeName="aShip";
	



	Image = LoadSprite(_DATA_FOLDER_+"/graph/ship/ship.bmp");
	
	for (int i=0;i<20; i++)
	{
		KaboomImage[i] = LoadSprite(_DATA_FOLDER_+"/graph/kaboom/kaboom"+numstr(i)+".bmp");
	}
	


	x = screenwidth / 2 - 40;
	y = screenheight - 80 - 20;
	
	KaboomFrame=0;
	doExplode=false;

	soundPlayed=false;
	if (!(Sound = Mix_LoadWAV(stringchar(_DATA_FOLDER_+"/sound/ship.wav")))) error("Mix_LoadWAV 'ship.wav' fails");
}



aShip::~aShip()
{
	SDL_DestroyTexture(Image);

	for (int i=0;i<20; i++)
	{
		SDL_DestroyTexture(KaboomImage[i]);
	}

	Mix_FreeChunk(Sound);
}



void aShip::update(void *data)
{
	Uint32 *pInt = static_cast<Uint32*>(data);
	x=*pInt;

	Uint32 t = *(pInt+1);
	if (t==1)
	{
			aShot *myShot = new aShot(x+35);
			myScene->addNode(myShot);
	}


	list<Node*>::iterator it;

	for (it = myScene->Nodes.begin(); it != myScene->Nodes.end(); it++)
		if((*it)->nodeName=="aAsteroid")
		{
			if( ((y-60) <= ((aAsteroid*) (*it))->y ) &&  (((aAsteroid*) (*it))->x+60 >= (x)) && (((aAsteroid*) (*it))->x <= (x+80)) )
																
			{
				doExplode=true;
				((aAsteroid*) (*it))->quiet=true;
				((aAsteroid*) (*it))->explode=true;
				break;
			}
		}




	if (doExplode)
	{
		if (!soundPlayed)
		{
			soundPlayed=true;
			if(!Mix_PlayChannel(1, Sound, 0)) error("Mix_PlayChannel1 'Ship' fails");
		}

		KaboomFrame++;
		if (KaboomFrame>=20) 
		{
			nodeAlive=false;
		}
	}
}


void aShip::render()
{
	
	if (!nodeAlive) return;

	SDL_Rect myrect;

	if (!doExplode)
	{
		SDL_QueryTexture(Image, NULL, NULL, &myrect.w, &myrect.h);
		myrect.x=x;
		myrect.y=y;

		SDL_RenderCopy(SDLren, Image, NULL, &myrect);
	} else {
		SDL_QueryTexture(KaboomImage[KaboomFrame], NULL, NULL, &myrect.w, &myrect.h);
		myrect.x=x;
		myrect.y=y;

		SDL_RenderCopy(SDLren, KaboomImage[KaboomFrame], NULL, &myrect);
	}
}
