#include <SDL.h>
#include <SDL_image.h>
#include "tools.h"

#include "aShot.h"
#include "SDLgraph.h"
#include "main.h"

#include "aAsteroid.h"

SDL_Texture* aShot::Image = NULL;
Mix_Chunk* aShot::Sound = NULL;

aShot::aShot(int x) 
{
	nodeName="aShot";

	
	if (!Image) Image = LoadTexture(_DATA_FOLDER_+"/graph/ship/shot.png");
	if (!Sound) if (!(Sound = Mix_LoadWAV(stringchar(_DATA_FOLDER_+"/sound/shot.wav")))) error("Mix_LoadWAV 'shot.wav' fails");
	
	if(!Mix_PlayChannel(1, Sound, 0)) error("Mix_PlayChannel1 'shot' fails");

	this->x = x; 
	y=screenheight-80-35;
}



aShot::~aShot()
{
	SDL_DestroyTexture(Image);
	Mix_FreeChunk(Sound);
}



void aShot::update(void *data)
{
	if (y>-27) 
	{
		y-=shotspeed; 
	}
	else 
	{
		nodeAlive=false;
	}


	
	list<Node*>::iterator it;

	for (it = myScene->Nodes.begin(); it != myScene->Nodes.end(); it++)
					if((*it)->nodeName=="aAsteroid")
					{
						if( (y <= ((aAsteroid*) (*it))->y+60) && (x >= ((aAsteroid*) (*it))->x) && (x <= ((aAsteroid*) (*it))->x+60))
						{
							curScore++;
							nodeAlive=false;
							((aAsteroid*) (*it))->explode=true;
							
							break;
						}
					}





}


void aShot::render()
{
	SDL_Rect myrect;

	SDL_QueryTexture(Image, NULL, NULL, &myrect.w, &myrect.h);
	myrect.x=x;
	myrect.y=y;

	SDL_RenderCopy(SDLren, Image, NULL, &myrect);
}
