#include <SDL.h>
#include <SDL_image.h>
#include "tools.h"
#include "main.h"
#include "SDLgraph.h"
#include "aStar.h"


using namespace std;


SDL_Texture *StarImage[18];

void LoadStarImageData()
{
	for (int i=0;i<18; i++)
	{
		StarImage[i] = LoadSprite(_DATA_FOLDER_+"/graph/stars/star"+numstr(i)+".bmp");
	}
}


void FreeStarData()
{	
	for (int i=0;i<18; i++)
	{
		SDL_DestroyTexture(StarImage[i]);
	}
}



aStar::aStar()
{

	nodeName="aStar";

	newstar=true;

	x = rand()%screenwidth;
	y = rand()%screenheight;
    
	speed = randomRange(1,4);
	starkind=rand()%2+1;

	starsprite=17;

	if (starkind==2)
	{
		starsprite=rand()%18;
	}


}

aStar::~aStar()
{

	

}


void aStar::render()
{

		
		SDL_Rect myrect;                
		SDL_QueryTexture(StarImage[starsprite], NULL, NULL, &myrect.w, &myrect.h);
		myrect.x=x;
		myrect.y=y;

		SDL_RenderCopy(SDLren, StarImage[starsprite], NULL, &myrect);

}


void aStar::reset()
{
		newstar=false;
		y = 0;
		x = rand()%screenwidth;
		speed=randomRange(1,5);
		starkind=rand()%2+1; 

		if (starkind==2)
		{
			starsprite=rand()%18;
		}
}

void aStar::update(void *data)
{

	y+=speed;

	if (y>=screenheight) reset();

}