#include "OSdefine.h"


#ifdef _TARGET_WINDOWS_
 #include <Windows.h>
#endif

#ifdef _TARGET_ANDROID_
 #include <android/log.h>
#endif

#include <string>
#include <sstream>
#include <stdlib.h>

#include "Tools.h"

using namespace std;



string pcharstr(unsigned char* pch)
{
	if (!pch) return "";
	string s="";
	int i=0;
	char ch=0xff;
	while(ch!=0)
	{
		ch=pch[i];
		if (ch!=0) s=s+ch;
		i++;
	}
	return s;
}


double deg2rad(double degree)
{
	double radian = 0;
	radian = degree * (PI/180);
	return radian;
}




float strfloat(string str)
{
    char *pch = new char[str.length()];

	unsigned int i=0;
	while (i<str.length())
	{
		pch[i]=str[i];
		i++;
	}
	
	float j;
	j=(float) atof(pch);
	delete[] pch;
	return j;

}

int strnum(string s)
{
	char *pch = new char[s.length()];

	unsigned int i=0;
	while (i<s.length())
	{
		pch[i]=s[i];
		i++;
	}
	
	int j;
	j=atoi(pch);
	delete[] pch;
	return j;
}


string numstr(int i)
{
	stringstream out;
	out << i;

	return out.str();
}

string GetDigitNumber(int dig)
{
	if(dig<10)
	{
		return "0" + numstr(dig); 
	}
	/*
	if((dig>=10) && (dig<100))
	{
		return "0" + numstr(dig);
	}
	*/
	return numstr(dig);

}

string floatstr(float f)
{
	stringstream oss;
	oss << f;
	string str;
	str = oss.str();

	return str;
}



char* stringchar(string s)
{
	unsigned long len=s.length();

	char *c;

	c=new char [len+1];
	
	for (unsigned long i=0;i<s.length();i++)
	{
		c[i]=s[i];
	}

	c[len]=0;

	return c;
}


#ifdef _TARGET_WINDOWS_
wstring s2ws(const string& s)
{
    int len;
    int slength = (int)s.length() + 1;
    len = MultiByteToWideChar(CP_ACP, 0, s.c_str(), slength, 0, 0); 
    wchar_t* buf = new wchar_t[len];
    MultiByteToWideChar(CP_ACP, 0, s.c_str(), slength, buf, len);
    wstring r(buf);
    delete[] buf;
    return r;
}
#endif


void CreateLogFile()
{
  filebuf fb;
  fb.open ("logger.log",ios::out);
  ostream os(&fb);
  os << "[LOG]\n";
  fb.close();
}


void log(string Text)
{

#ifdef _TARGET_ANDROID_
	__android_log_write(ANDROID_LOG_INFO, "log", stringchar(Text));
#endif

  filebuf fb;
  fb.open ("logger.log",ios::app);
  ostream os(&fb);
  os << Text << "\n";
  fb.close();
}

void log(int num)
{
	log(numstr(num));
}








float myrandom()
{
    return rand() / static_cast<float>(RAND_MAX);
}
 

int randomRange( int low, int high )
{
    int range = high - low;
    return static_cast<int>(myrandom() * range) + low;
}



void error(string thetext)
{
	log("[ERROR] "+thetext);

#ifdef _TARGET_WINDOWS_
	wstring stemp = s2ws(thetext);
	LPCWSTR result = stemp.c_str();

	MessageBoxW(NULL,(LPCWSTR) result, L"Error", MB_OK);	
#endif

	exit(-1);
}

void makeMessage(string thetext)
{
	log("[MESSAGE] "+thetext);

#ifdef _TARGET_WINDOWS_
	wstring stemp = s2ws(thetext);
	LPCWSTR result = stemp.c_str();

	MessageBoxW(NULL,(LPCWSTR) result, L"Message", MB_OK);	
#endif
}














void sortUint(unsigned int* &arr)
{
	for(int j = 9; j >= 0; j--)
	{
	  for(int i = 0; i < j; i++)
	  {
		if(arr[i] > arr[i + 1])
		{
		  int temp = arr[i + 1];
		  arr[i + 1] = arr[i];
		 arr[i] = temp;
		}
	  }
	}
}



/*
int* InsertArray(int* arr1,int numArr1, int* arr2, int numArr2, int& numAUX)
{
	numAUX=0;

	vector <int> arr;

	if (numArr1==0) goto endlabel;
	if (numArr2==0) goto endlabel;

	int x=0,y=0;
	int i=0;

	int num1=0,num2=0;

	int count=0;
	if (numArr1>=numArr2) count=numArr1; else count=numArr2;

	bool overflowX=false;
	bool overflowY=false;

	while(numAUX<count)
	{
		if (x<numArr1) num1=arr1[x]; else num1=2147483647; // { overflowX=true; break; }
		if (y<numArr2) num2=arr2[y]; else num2=2147483647; // { overflowY=true; break; }

		if (num1<num2)
		{
			arr.push_back(arr1[x]);
			x++;
			// count++;
		}	

		if (num1==num2)
		{
			arr.push_back(arr1[x]);
			x++;
			y++;
		}

		if (num1>num2)
		{
			arr.push_back(arr2[y]);
			y++;
			count++;
		}

			numAUX++;
	}

	
	if (overflowX)
	{
	log("overflowX "+numstr(count));
		for (i=numAUX;i<=count;i++)
		{
			arr.push_back(arr2[y]);
			y++;
			numAUX++;
		}
	}

	if (overflowY)
	{
		log("overflowY "+numstr(count));
		for (i=numAUX;i<=count;i++)
		{
			arr.push_back(arr1[x]);
			x++;
			numAUX++;
		}
	}
	
endlabel:

	if ((numArr1==0) && (numArr2!=0)) 
	{
		for (int i=0;i<numArr2;i++)
		{
			arr.push_back(arr2[numAUX]);
			numAUX++;
		}
	} else
	if ((numArr2==0) && (numArr1!=0)) 
	{
		for (int i=0;i<numArr1;i++)
		{
			arr.push_back(arr1[numAUX]);
			numAUX++;
		}
	} else
	if ((numArr1==0) && (numArr2==0)) 
	{
		numAUX=0; 
		int* aux = new int [1];
		return aux;
	} 

	int* aux = new int [numAUX];

	for (int i=0;i<numAUX;i++) 
	{
		aux[i]=arr[i];
	}

    return aux;
}

*/